import { Fetcher, RequestCreator, FetcherOptions, RequestOptions, Cache } from './types';
export declare class FetcherImpl<T, R = void> implements Fetcher<T, R> {
    private options;
    private requestFactory;
    private ongoingClearCache;
    constructor(requestCreator: RequestCreator<T, R>, options?: FetcherOptions);
    config(options?: FetcherOptions): void;
    clearCache(maxAge?: number, cache?: Cache<unknown>): Promise<void>;
    fetch(request?: R, options?: RequestOptions): {
        abort: () => void;
        response: Promise<import("./types").RequestResponse<T>>;
    };
}
