import { MutableRefObject } from 'react';
/**
 * shallow equal - object and its properties - compare
 * @param objA
 * @param objB
 * @returns
 */
export declare function isShallowEqual<T>(objA: T, objB: T): boolean;
export declare function isEqualForKeys<T extends {}>(objA: T, objB: T, keys: (keyof T)[]): boolean;
/**
 * deep equal compare
 * @param value1
 * @param value2
 * @returns
 */
export declare function isDeepEqual<T>(value1: T, value2: T): boolean;
/**
 * use memo instance if value is consider to be not changed during render by shallow equal comparsion
 * @param value
 * @returns
 */
export declare function useShallowEqualMemo<T>(value: T): T;
/**
 * use memo instance if value is consider to be not changed during render by deep equal comparsion
 * @param value
 * @returns
 */
export declare function useDeepEqualMemo<T>(value: T): T;
/**
 * component rerender trigger
 */
export declare function useRerender(): () => void;
/**
 * debounced state update/rerender
 * @returns [state, offscreenStateRef, updateState, cancel]
 */
export declare function useHookStateRef<T>(initialState: T): [T, MutableRefObject<T>, (fragment: Partial<T>) => void, () => void];
