import { RequestResponse, Logger, RequestOptions } from '../types';
import { FetcherRequest, RequestControl } from './utils';
/**
 * Polling request, handles client polling
 */
export declare class PollingFetcherRequest<T, R> implements FetcherRequest<T> {
    private requestControl;
    private cacheKey;
    private options;
    private request?;
    private logger?;
    private innerRequest;
    private isAborted;
    private responseResolve;
    private pollingTimeout;
    constructor(requestControl: RequestControl<T, R>, cacheKey: string, options: RequestOptions, request?: R, logger?: Logger);
    run(): Promise<RequestResponse<T>>;
    abort(): void;
}
