import { RequestResponse, Logger, FetcherOptions } from '../types';
import { FetcherRequest, RequestControl } from './utils';
/**
 * SWR request, handles request with cache
 */
export declare class SWRFetcherRequest<T, R> implements FetcherRequest<T> {
    private requestControl;
    private cacheKey;
    private request?;
    private logger?;
    private cacheControl;
    private isRequestSent;
    private isAborted;
    private responseResolve;
    constructor(requestControl: RequestControl<T, R>, cacheKey: string, options: FetcherOptions, request?: R, logger?: Logger);
    run(): Promise<RequestResponse<T>>;
    abort(): void;
}
