import { RequestResponse, FetcherOptions, Logger } from '../types';
export interface FetcherRequest<T> {
    run(): Promise<RequestResponse<T>>;
    abort(): void;
}
export interface RequestControl<T, R> {
    getResponse(cacheKey: string, request?: R): Promise<T>;
    release(cacheKey: any): void;
}
export declare const AbortErrorName = "AbortError";
export declare function createAbortError<T>(): RequestResponse<T>;
export declare type PromiseResolve<T> = (data?: T) => void;
export interface PromiseWithControls<T> {
    promise: Promise<T>;
    resolve: PromiseResolve<T>;
    reject: (err?: Error) => void;
}
export declare function createPromise<T>(): PromiseWithControls<T>;
export declare function proxyResponseWithAdditionalNext<T>(response: RequestResponse<T>, onEnd: (res: RequestResponse<T>) => Promise<RequestResponse<T>> | undefined): RequestResponse<T>;
export declare function getFetcherRequestLogger<R>(name: string, options: FetcherOptions, cacheKey: string, request?: R): Logger | undefined;
